;**********************************************************************************
;**********************************************************************************
;********************     LIBRAIRIE BRES.H    *************************************
; Son but est de tracer une ligne en utilisant l'algorithme de Bresham.
;(si ca se trouve la fonction equivalente graphlib est plus rapide mais ca m'etonnerait)
;**********************************************************************************
;**********************************************************************************


;***  Traduction de quelques instructions en langage machine :
intr_nop EQU $4E71      ;pratiquement sur
intr_inc_d0 EQU $5240
intr_inc_d1 EQU $5241
intr_inc_d2 EQU $5242
intr_inc_d3 EQU $5243
intr_dec_d0 EQU $5340
intr_dec_d1 EQU $5341
intr_dec_d2 EQU $5342
intr_dec_d3 EQU $5343

;***********************************************************************************
;*******************  PROCEDURE DESSINANT UNE LIGNE (clippe le cas cheant)  ******
;***********************************************************************************
;***  Trace une ligne pouvant sortir de l'cran utilisant l'algo de Bresenham ;
;     certes c'est moins rapide que fline (de la librairie linelib) mais je n'ai pas
;     voulu le reprendre car il est illisible .Et de toute maniere l'ago. semble
;     clairement ne pas voir de solution pour faire un programme rapide gerant le clipping.
;***  Paramtre d'entre :  - a0 represente l'adresse dans lequel la ligne est dessine
;                           - d0.w abscisse du premier point de la ligne
;                           - d1.w ordonne du premier point de la ligne
;                           - d2.w abscisse du second point de la ligne
;                           - d3.w ordonne du second point de la ligne

bline:

  move.w #intr_inc_d0,d4   ;prpare l'automodification dans d4.w
  move.w #intr_inc_d1,d5   ;... et d5.w
                           ;d4 est la premire instruction  executer, d5 la seconde.

  sub.w d0,d2             ;value deltax
  bpl deltax_ok           ;ngatif ?
  neg.w d2                ;oui, change le signe de deltax
  move.w #intr_dec_d0,d4  ;et dec d2 au lieu de inc d2
deltax_ok:
  sub.w d1,d3             ;calcule deltay
  bpl deltay_ok           ;ngatif ?
  neg.w d3                ;oui, change le signe de deltay
  move.w #intr_dec_d1,d5   ;et dec d5 au lieu de inc d5
deltay_ok:
  move.w d2,d6            ;deltay et
  or.w   d3,d6            ;deltax = 0 ?
  bne trace_la_ligne
  rts                     ;oui alors on arrte le trac
trace_la_ligne:
  lea dist_pos,a1
  move.w d4,(a1)+         ;crit dec/inc deltax
  move.w d5,(a1)          ;crit dec/inc deltay

  cmp.w d3,d2             ;deltax >= deltay ?
  bge deltax_grand

  exg    d3,d2            ;non, alors change deltax et deltay 
  move.w #intr_nop,d4     ;et change inc ax en nop
  jmp constantes
deltax_grand:
  move.w #intr_nop,d5     ;sinon change inc bx en nop
constantes:
  lea dist_neg,a1
  move.w d4,(a1)+         ;crit dec/inc deltax
  move.w d5,(a1)          ;crit dec/inc deltay

;***  Automodification effectue d4 et d5 peuvent servir  autre chose:
  move.w d3,d6
  asl.w  #1,d6
  move.w d6,d5            ;d5 = Add_2 = 2*delta_y
  sub.w  d2,d6            ;d6 = Start_Dist = 2*delta_y - delta_x
  move.w d6,d4
  sub.w  d2,d4            ;d4 = Add_1 = 2*(delta_y-delta_x)

;hjk:
; jmp hjk

loop_b:

;dessine un point en (d2,d3)
;***  Affiche le pixel ? (partie clipping  une extremite)
 cmpi.w #160,d0
 bge    pas_de_pixel_affiche
 cmpi.w #100,d1
 bge    pas_de_pixel_affiche

;oui
;***  a1 = adresse_de_l_ecran_virtuel + (d1*30 + d0) div 8
  move.l adresse_de_l_ecran_virtuel,a1
  move.w d1,d7
  bmi    pas_de_pixel_affiche   ;pas besoin de continuer les calculs car le pixel ne sera pas affiche
  ext.l  d7
  move.l d7,d3
  asl.l	 #5,d7
  asl.l  #1,d3
  sub.l  d3,d7
  move.w d0,d3
  bmi    pas_de_pixel_affiche   ;pas besoin de continuer les calculs car le pixel ne sera pas affiche
  asr.w  #3,d3
  ext.l  d3
  add.l  d3,d7
  adda.l d7,a1            ;a1 pointe sur le dbut de la ligne
;alors on affiche le pixel:
  move.b d0,d7
  not.b  d7
  bset d7,(a1)

pas_de_pixel_affiche:

  tst.w d6                ;Dist positif ?
  bpl dist_pos
dist_neg:
  nop                     ;place pour l'automodification
  nop                     ;place pour l'automodification
  add.w d5,d6             ;met  jour Dist 
  subq.w #1,d2            ;point suivant
  bne    loop_b
  jmp fini_b              ;c'est termin
dist_pos:
  nop                     ;place pour l'automodification
  nop                     ;place pour l'automodification
  add.w d4,d6             ;met  jour Dist 
  subq.w #1,d2            ;point suivant
  bne    loop_b
fini_b:

;***  Fin de la procdure
  rts

