;****************************************************************************************
;*****************   LIBRAIRIE tpoly   **************************************************
;Son but est d'afficher un polygone mappe (le plus gros du boulot)
;****************************************************************************************
;*****************   Amlioration  :   **************************************************
;****************************************************************************************
;***  Ajout de nouvelles fonction: 
;     - draw_lined_polygon : dessin d'un polygone remplie de blanc, bord de noir.

;***  Important pour utiliser cette procdure :
;     a0 doit contenir l'adresse o afficher le polygone
;       !a0 et autres registres sont generalement modifies par le programme !
;     le polygone est afficher  l'adresse de la variable adresse_de_l_ecran_virtuel
;       !Attention! adresse_de_l_ecran_virtuel doit tre dfinit dans le prgm principal

;***  Inclut les macros
 include spoly7.h

draw_textured_polygon:
;*************************************************************************************
;**********************   Dtermine l'ordonne minimale et maximale :   **************
;*************************************************************************************

 move.l adresse_de_l_ecran_virtuel,tampon_ecran

 lea polygone,a4
 move.w (a4)+,d7                ;charge le nbre d'itrations
 lea coordonnees_de_mapping,a6
;***  a6:=addr(coordonnes_de_mapping)-addr(polygone)
 suba a4,a6

 move.l a4,a2
 move.l a4,coord_min            ;coord_min pointe sur la premiere ordonne du polygone
 move.w 2(a4),ymax              ;ymax=premiere valeur
 move.w 2(a4),ymin              ;    =ymin
 lea 4(a4),a4                   ;on pointe sur le prochain point

mini_maxi:
 subq.w #1,d7
 beq fin_mini_maxi              ;fin du polygone
 move.l (a4)+,d0                ;d0.l:=abscisse.w + ordonne.w

 cmp.w ymax,d0                  ;compare l'ordonne maxi avec celle courante
 ble no_new_maxi
 move.w d0,ymax                 ;nouveau maximum
no_new_maxi:
 cmp.w ymin,d0
 bge mini_maxi
 move.w d0,ymin                 ;nouveau minimum
 lea -4(a4),a2                  ;a2 pointe sur le minimum
 jmp mini_maxi

fin_mini_maxi:

 lea -4(a4),a4
 move.l a4,coord_max         ;coord_max pointe sur la derniere ordonne du polygone

;*** Si ymax<0 de l'cran on arrte le tracage
 cmpi.w #0,ymax
 blt fin_du_tracage

;*** Si ymax>hauteur de l'cran on arrte le tracage
 cmpi.w #LCD_HEIGHT,ymin
 bgt fin_du_tracage

;***  Calcul de l'increment principal :
 movea.l a2,a3               ;a3,a2 pointent ts les deux sur le maximum
 movea.l a2,a4               ;Prserve a2
;On prend les points suivant:
 point_suivant_gauche pinc
 point_suivant_droit  pinc

 mapping

;***  Fin du calcul de l'incrment principal.

 movea.l a4,a2
 movea.l a4,a3

;***  on commence  la ligne ymax :
 moveq.l #0,d0
 move.w ymin,d0          ;ymin est en haut de l'cran
 move.w d0,yi            ;Ne soyez pas tentez pour optimiser l, OK ?

;***  On suppose que a0 contient dj l'adresse de destination pour crire l'image
 tst.w yi
 bmi clip_haut_pas_de_dcalage  ;Pas d'adresse ngative non non et non
 move.l d0,d1
 asl.l #5,d0
 asl.l #1,d1
 sub.l d1,d0
 add.l d0,tampon_ecran
clip_haut_pas_de_dcalage:

;***  a0 est cens pointer sur la ligne ymin  l'cran

;***  partie du clipping :
 move.w #LCD_HEIGHT,d0
 cmp.w  ymax,d0
 bgt no_clip_bas           ;si ymax < hauteur_de_l_ecran
 subq.l #1,d0
 move.w d0,ymax            ;alors aucune raison de dpasser la hauteur de l'cran
no_clip_bas:

;*************************************************************************************
;*******  Affichage du polygone (Boucle principale) :  *******************************
;*************************************************************************************
next_line:
;************************************************************************************
;***  si y<=ymin ou y<0 on arrte le trac : (clipping haut)*************************
;************************************************************************************
;***  On le teste ds le dbut pour envisag le cas du polygone plat (suivant l'horizontale)
 move.w ymax,d0
 cmp.w yi,d0
 ble fin_du_tracage             ;si yi > ymax alors on arrte

 increment_ligne_gauche
 increment_ligne_droit

 tst.w yi
 bmi   clip_haut

;************************************************************************************
;***************   Affichage de la ligne avec la texture :   ************************
;************************************************************************************
;************************************************************************************

 move.w pos_gauche,d2
 asr.w  #7,d2                    ;d2 contient l'absice courant gauche
 cmpi.w #LCD_WIDTH,d2
 bge y_a_plus_de_ligne           ;partie du clipping : cas ou on ne dessine pas du tout la ligne
 move.w pos_droit,d3
 asr.w  #7,d3                    ;d3 contient l'absice courant gauche
 bmi y_a_plus_de_ligne

;******************   PREPARE LES PARAMETRES (INCREMENTS) POUR DESSINER LA LIGNE  ************
 moveq.l #0,d7
 move.w  d3,d7
 sub.w   d2,d7       ;d7 est le nombre d'itrations (x2_clipp - x1_clipp)
; beq     y_a_plus_de_ligne
 bmi     y_a_plus_de_ligne
                     ;Si delta_x est <= 0 alors on ne trace pas la ligne


;***  On charge les coordonne map de dpart :
; (simple)
;***  sur x
 move.l texture_pos_gauche_x,d4
;***  sur y
 move.l texture_pos_gauche_y,d5

 tst.w d2
 bpl no_clip_gauche

 move.w d3,d7          ;nbre d'incrementation = d3
 neg.w  d2
;***  Ajuste le clipping gauche sur x
 move.l increment_principal_x,d1
 muls   d2,d1
 add.l  d1,d4
;et sur y
 move.l increment_principal_y,d1
 muls   d2,d1
 add.l  d1,d5
 clr.w d2

no_clip_gauche:

;***  Charge le dpart de l'image:
 movea.l tampon_ecran,a1

;***  a6 pointe sur le long word ou la ligne doit s'afficher.

 moveq.l #0,d0
 move.w d2,d0
 asr.w  #3,d0        ;d0:=(x1_clipp) div 8

 adda.l d0,a1        ;a1 pointe maintenant sur le long word  afficher
                     ;en rsum a6:=#LCD_MEM + y * 300 + x div 32

;Calcule le dcalage  "l'intrieur" du long word pour l'affichage de la ligne
 move.b d2,d6
 not.b  d6           ;d6:=dcalage en bits
 andi.b #7,d6

;***  Clipping droit tout  la fin

 move.l #LCD_WIDTH,d0
 cmp.w d7,d0
 bgt no_clip_droit

 subq.w #1,d0
 move.w d0,d7            ;nouveau nbre d'incrment=largeur de l'cran

no_clip_droit:

;***  On adapte le format :
 moveq.l #0,d0
 move.b d5,d0
 ror.l	#8,d0

 move.l d4,d1
 asr.w #8,d1
 asr.w #8,d5
 muls  #largeur_de_l_image,d5
 add.w d1,d5
 add.l d0,d5

 lea image,a0
 add.l a0,d5

 move.b special_add1,d2
 move.l special_add2,d3

;***  Rcapitulation des paramtres demands en entre de boucle :
;       a6 pointe sur l'octet du dbut de la ligne  afficher
;        d6 est le dcalage en bits en (a6) du dbut de la ligne  afficher
;       d4 est la position map de texture sur x de dpart
;       d2 est l'incrment sur x de la texture
;       idem pour d3,d5 pour les coordonnes map sur y

;***  Boucle d'affichage de la ligne :

 move.b (a1),d1                 ;on charge l'ancien tat du word

n_pixel_suivant:

;***  Calcul la vraie adresse de la texture
 add.b d2,d4
 addx.l d3,d5
 bcc    no_carry_flag
 addi.l #largeur_de_l_image,d5
no_carry_flag:
 move.l d5,a0

 tst.b (a0)                      ;on teste le pixel source
 beq    pas_de_pixel             ;Allum

;***  Affiche le pixel :
 
 bset.b d6,d1                    ;oui alors on allume le pixel dans le registre tampon : d1
                                 ;OU logique avec l'ancien tat du pixel

;***   Point suivant :
 subq.b #1,d6                ;dcalage du masque
 bpl n_meme_mot
 jmp n_mot_suivant

;***  Eteint le pixel :
pas_de_pixel:                    ;sinon rien ne se passe
 bclr.b d6,d1

;***   Point suivant :
 subq.b #1,d6                ;dcalage du masque
 bpl n_meme_mot

;Est ce qu'on passe au word suivant pour l'criture du pixel :
;oui
n_mot_suivant:
 move.b d1,(a1)+                 ;On affiche le mot (paquet de 16 pixel)
 move.b #7,d6
 move.b (a1),d1                  ;On prend l'ancien tat du mot
 DBra d7,n_pixel_suivant
 jmp n_dernier_mot

;non
n_meme_mot:
 DBra d7,n_pixel_suivant

;***  Dernier word  afficher
n_dernier_mot:
 move.b d1,(a1)               ;Ou logique pour afficher 16 pixel - un mot

y_a_plus_de_ligne:

;************************************************************************************
;***  On dcrmente le pointeur sur la ligne  afficher
 add.l #largeur_reelle_de_l_ecran_en_octets,tampon_ecran

clip_haut:

;***  prochaine ligne  tracer : on dcrmente y
 addq.w #1,yi

;***   Incrment de ligne :

 move.w inc_droit,d0
 add.w d0,pos_droit

 move.w inc_gauche,d0
 add.w d0,pos_gauche

 move.l texture_inc_gauche_x,d0
 add.l d0,texture_pos_gauche_x

 move.l texture_inc_gauche_y,d0
 add.l d0,texture_pos_gauche_y

 jmp next_line


fin_du_tracage:

 rts

;*************************************************************************************
;*************************************************************************************
;******          PROCEDURE   DRAW_LINED_POLYGON                     ******************
;*************************************************************************************
;*************************************************************************************
;*************************************************************************************
;*************************************************************************************
;******          PROCEDURE   DRAW_LINED_POLYGON                     ******************
;*************************************************************************************
;*************************************************************************************
;*************************************************************************************
;*************************************************************************************
;******          PROCEDURE   DRAW_LINED_POLYGON                     ******************
;*************************************************************************************
;*************************************************************************************

draw_lined_polygon:
;*************************************************************************************
;**********************   Dtermine l'ordonne minimale et maximale :   **************
;*************************************************************************************

;bidd:
; jmp bidd

 move.l adresse_de_l_ecran_virtuel,tampon_ecran

 lea polygone,a4
 move.w (a4)+,d7                ;charge le nbre d'itrations
 lea coordonnees_de_mapping,a6
;***  a6:=addr(coordonnes_de_mapping)-addr(polygone)
 suba a4,a6

 move.l a4,a2
 move.l a4,coord_min            ;coord_min pointe sur la premiere ordonne du polygone
 move.w 2(a4),ymax              ;ymax=premiere valeur
 move.w 2(a4),ymin              ;    =ymin
 lea 4(a4),a4                   ;on pointe sur le prochain point

mini_maxi_2:
 subq.w #1,d7
 beq fin_mini_maxi_2              ;fin du polygone
 move.l (a4)+,d0                ;d0.l:=abscisse.w + ordonne.w

 cmp.w ymax,d0                  ;compare l'ordonne maxi avec celle courante
 ble no_new_maxi_2
 move.w d0,ymax                 ;nouveau maximum

no_new_maxi_2:
 cmp.w ymin,d0
 bge mini_maxi_2
 move.w d0,ymin                 ;nouveau minimum
 lea -4(a4),a2                  ;a2 pointe sur le minimum
 jmp mini_maxi_2

fin_mini_maxi_2:

 lea -4(a4),a4
 move.l a4,coord_max         ;coord_max pointe sur la derniere ordonne du polygone

 move.w ymax,d0                 ; polygone plat ?
 cmp.w  ymin,d0
 beq    fin_du_tracage_2        ; Alors on ne dessine pas le polygone

;*** Teste si le polygone est affiche ou est vu de derrire :

 movea.l a2,a3               ;a3,a2 pointent ts les deux sur le maximum
; movea.l a2,a4               ;Prserve a2
; movea.l a2,a5
;On prend les points suivant:
; point_suivant_gauche pinc_2
; point_suivant_droit  pinc_2

; move.w (a4)
; move.w (a3),d0


; cmp.w  (a2),d0
; bmi    polygone_trace       ;si x_gauche > x_droit alors le polygone n'est pas dessin

; movea.l a4,a2
; movea.l a4,a3

;***  Bhon ben on va affciher le polygone :

;*** Si ymax<0 de l'cran on arrte le tracage
 cmpi.w #0,ymax
 blt fin_du_tracage_2

;*** Si ymax>hauteur de l'cran on arrte le tracage
 cmpi.w #LCD_HEIGHT,ymin
 bgt fin_du_tracage_2

;***  on commence  la ligne ymax :
 moveq.l #0,d0
 move.w ymin,d0          ;ymin est en haut de l'cran
 move.w d0,yi            ;Ne soyez pas tentez pour optimiser l, OK ?


;***  On suppose que a0 contient dj l'adresse de destination pour crire l'image
 tst.w yi
 bmi clip_haut_pas_de_dcalage_2  ;Pas d'adresse ngative non non et non
 move.l d0,d1
 asl.l #5,d0
 asl.l #1,d1
 sub.l d1,d0
 add.l d0,tampon_ecran
;***  On passe  la ligne suivante car la premire est une ligne noire
 add.l #largeur_reelle_de_l_ecran_en_octets,tampon_ecran
clip_haut_pas_de_dcalage_2:

;***  a0 est cens pointer sur la ligne ymin  l'cran

;***  clipping du bas :
 move.w #LCD_HEIGHT,d0
 cmp.w  ymax,d0
 bgt no_clip_bas_2         ;si ymax < hauteur_de_l_ecran
 subq.l #1,d0
 move.w d0,ymax            ;alors aucune raison de dpasser la hauteur de l'cran
no_clip_bas_2:

 subq.w #1,ymax
;*************************************************************************************
;*******  Affichage du polygone (Boucle principale) :  *******************************
;*************************************************************************************
next_line_2:

;***  prochaine ligne  tracer : on incrmente y
 addq.w #1,yi

 increment_ligne 3,gauche,a2,a4
 increment_ligne 4,droit,a3,a5

;***  On le teste ds le dbut pour envisag le cas du polygone plat (suivant l'horizontale)
 move.w ymax,d0
 cmp.w yi,d0
 ble fin_du_tracage_2             ;si yi >= ymax alors on arrte

 tst.w yi
 bmi   clip_haut_2

 move.w pos_gauche,d2
 asr.w  #7,d2                    ;d2 contient l'absice courant gauche

 cmpi.w #LCD_WIDTH,d2
 bge y_a_plus_de_ligne_2          ;partie du clipping : cas ou on ne dessine pas du tout la ligne
 move.w pos_droit,d3
 asr.w  #7,d3                    ;d3 contient l'absice courant gauche
 bmi y_a_plus_de_ligne_2

;******************   PREPARE LES PARAMETRES (INCREMENTS) POUR DESSINER LA LIGNE  ************
 moveq.l #0,d7
 move.w  d3,d7
 sub.w   d2,d7                   ;d7 est le nombre d'itrations (x2_clipp - x1_clipp)
 beq     y_a_plus_de_ligne_2
 bmi     polygone_trace
                                 ;Si delta_x est <= 0 alors on ne trace pas la ligne

 tst.w d2
 bpl no_clip_gauche_2

 move.w d3,d7          ;nbre d'incrementation = d3
 clr.w d2

no_clip_gauche_2:

;***  Charge le dpart de l'image:
 movea.l tampon_ecran,a1

;***  a6 pointe sur le long word ou la ligne doit s'afficher.

 moveq.l #0,d0
 move.w d2,d0
 asr.w  #3,d0        ;d0:=(x1_clipp) div 8

 adda.l d0,a1        ;a1 pointe maintenant sur le long word  afficher
                     ;en rsum a6:=#LCD_MEM + y * 300 + x div 32

;Calcule le dcalage  "l'intrieur" du long word pour l'affichage de la ligne
 move.b d2,d6
 not.b  d6           ;d6:=dcalage en bits
 andi.b #7,d6        ;il faut que d6 soit positif pour le test d'aprs

;***  Clipping droit tout  la fin

 move.l #LCD_WIDTH,d0
 cmp.w d7,d0
 bgt no_clip_droit_2

 subq.w #1,d0
 move.w d0,d7            ;nouveau nbre d'incrment=largeur de l'cran

no_clip_droit_2:

;***  Rcapitulation des paramtres demands en entre de boucle :
;       a6 pointe sur l'octet du dbut de la ligne  afficher
;       d6 est le dcalage en bits en (a6) du dbut de la ligne  afficher

;***  Boucle d'affichage de la ligne :

 move.b (a1),d1                 ;on charge l'ancien tat du word

n_pixel_suivant_2:

;***  Efface le pixel :
 
 bclr.b d6,d1                    ;oui alors on allume le pixel dans le registre tampon : d1
                                 ;OU logique avec l'ancien tat du pixel
;***   Point suivant :
 subq.b #1,d6                    ;dcalage du masque
 bpl n_meme_mot_2

 move.b d1,(a1)+                 ;On affiche le mot (paquet de 16 pixel)
 move.b #7,d6
 move.b (a1),d1                  ;On prend l'ancien tat du mot
 DBra d7,n_pixel_suivant_2
 jmp n_dernier_mot_2

;non
n_meme_mot_2:
 DBra d7,n_pixel_suivant_2

;***  Dernier word  afficher
n_dernier_mot_2:
 move.b d1,(a1)               ;Ou logique pour afficher 16 pixel - un mot

y_a_plus_de_ligne_2:
;***  On incrmente le pointeur sur la ligne  afficher
 add.l #largeur_reelle_de_l_ecran_en_octets,tampon_ecran

;************************************************************************************

clip_haut_2:

 jmp next_line_2

fin_du_tracage_2:

;***  On trace les bordures :
 move.w polygone,yi
dessiner_ligne_suivante:
 subq.w #1,yi
 bmi    polygone_trace
 movea.l a2,a4
 point_suivant_gauche dl
 move.w  (a2),d0
 move.w 2(a2),d1
 move.w  (a4),d2
 move.w 2(a4),d3
 bsr bline
 jmp dessiner_ligne_suivante
polygone_trace:
 rts

;*********************************************************************************************
;*********************************************************************************************
;*****                      DECLARATION DE VARIABLES                                   *******
;*********************************************************************************************
;*********************************************************************************************

ymin: dc.w 0
ymax: dc.w 0
pos_gauche: dc.w 0      ;position du curseur
inc_gauche: dc.w 0      ;incrment suivant x pour la ligne de gauche
pos_droit:  dc.w 0
inc_droit:  dc.w 0      ;idem pour la ligne de droite
yi:         dc.w 0      ;position de la ligne  tracer
coord_min:  dc.l 0      ;pointeur sur la coordonne minimum
coord_max:  dc.l 0      ;pointeur sur la coordonne maximum

increment_principal_x: dc.l 0
increment_principal_y: dc.l 0

special_add1: dc.w 0  ;pour avoir des adresses paires !!
special_add2: dc.l 0

tampon_ecran:	dc.l 0

texture_pos_gauche_x:   dc.l 0
texture_pos_gauche_y:   dc.l 0
texture_inc_gauche_x:   dc.l 0
texture_inc_gauche_y:   dc.l 0
longueur_du_parrallelogramme: dc.w 0


;delta_x: dc.w 0

largeur_reelle_de_l_ecran_en_octets EQU 30     ;que ce soit pour les ti-89 comme les ti-92